"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorNotDigit = new Error('Input is not a single digit');
exports.ErrorInvalidHexString = new Error('Can only convert strings containing hexadecimal digits');
function _isHex(input) {
    var _exec = /[\da-f]*/im.exec(input);
    return _exec ? _exec[0] === input : false;
}
exports._isHex = _isHex;
function _hexMap(input) {
    if (input && input.length === 1) {
        switch (input) {
            case 'a': return 10;
            case 'b': return 11;
            case 'c': return 12;
            case 'd': return 13;
            case 'e': return 14;
            case 'f': return 15;
            default: return +input;
        }
    }
    else {
        throw exports.ErrorNotDigit;
    }
}
exports._hexMap = _hexMap;
function convertHex(input) {
    if (_isHex(input)) {
        var length_1 = input.length;
        return input.split('').reduce(function (accum, value, index) { return (accum + (_hexMap(value) * (Math.pow(16, (length_1 - index - 1))))); }, 0);
    }
    else {
        throw exports.ErrorInvalidHexString;
    }
}
exports.default = convertHex;
//# sourceMappingURL=convert-hex.js.map